require "nServer"

local Call = nServer.call
local int2num = nServer.int2num
local num2int = nServer.num2int
local str2ul = nServer.str2ul
local peek = nServer.peek
local Ptr = nServer.Ptr
local bitops = nServer.bitops



OS = string.format("%X",int2num(peek("0x10000020",4)))
OSstr = "OS version unknown"
if OS == "102F0FA0" then
 puts = tonumber("102F0FA0",16) -- 3.1.0 non-CAS
 OSstr = "3.1.0 non-CAS"
end
if OS == "102F16D0" then
 puts = tonumber("102F16D0",16) -- 3.1.0 CAS
 OSstr = "3.1.0 CAS"
end
if OS == "102F0A10" then
 puts = tonumber("10378284",16) -- 3.1.0 non-CAS CX
 OSstr = "3.1.0 non-CAS CX" 
end
if OS == "102F11A0" then
 puts = tonumber("102F11A0",16) -- 3.1.0 CAS CX
 OSstr = "3.1.0 CAS CX"  
end


u = int2num(str2ul("0xe1234567"))
v = int2num(str2ul("0x12345678"))
w = int2num(num2int(v))

function on.paint(gc)
    gc:drawString("Lua native function tests",5,5,"top")  -- display string
    gc:drawString("u:"..u,5,20,"top")  -- display string
    gc:drawString("v:"..v,5,35,"top")  -- display string
    gc:drawString("w:"..w,5,50,"top")  --
    gc:drawString("OS:"..OSstr,5,65,"top")
    gc:drawString("conversions test finished",5,80,"top")  -- display string
end