require "nServer"

local Call = nServer.call
local int2num = nServer.int2num
local num2int = nServer.num2int
local str2ul = nServer.str2ul
local peek = nServer.peek
local Ptr = nServer.Ptr



OS = string.format("%X",int2num(peek("0x10000020",4)))
if OS == "102F0FA0" then
 puts = tonumber("102F0FA0",16) -- 3.1.0 non-CAS
 OSstr = "3.1.0 non-CAS"
end
if OS == "102F16D0" then
 puts = tonumber("102F16D0",16) -- 3.1.0 CAS
 OSstr = "3.1.0 CAS"
end
if OS == "102F0A10" then
 puts = tonumber("10378284",16) -- 3.1.0 non-CAS CX
 OSstr = "3.1.0 non-CAS CX" 
end
if OS == "102F11A0" then
 puts = tonumber("102F11A0",16) -- 3.1.0 CAS CX
 OSstr = "3.1.0 CAS CX"  
end

asmcode = str2ul("0xE1233373")            -- BKPT(3333) break into emulator debugger
asmcode = asmcode .. str2ul("0xE12FFF1E") -- BX LR -- back to Lua


collectgarbage("stop")  -- So Lua does not move the string "asmcode"
asmhex , asmnum =  Ptr(asmcode)
Call(asmhex)              -- run it: 
collectgarbage("restart") -- continue garbage collecting

function on.paint(gc)
    gc:drawString("Lua native function tests",5,5,"top")  -- display string
    gc:drawString("check emulator console",5,20,"top")  -- display string
    gc:drawString("asm test finished",5,35,"top")  -- display string
    gc:drawString(OSstr,5,50,"top")  -- display string
end